Index: branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/EqualsExpressions.cs
===================================================================
--- branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/EqualsExpressions.cs	(revision 14733)
+++ branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/EqualsExpressions.cs	(revision 14744)
@@ -9,10 +9,12 @@
   /// <typeparam name="T">Stacktype</typeparam>
   public abstract class EqualsExpression<T> : StatelessExpression {
-    public void Eval(IStack<T> stack, IStack<bool> booleanStack) {
-      if (stack.Count < 2) return;
+    public bool Eval(IStack<T> stack, IStack<bool> booleanStack) {
+      if (stack.Count < 2) return false;
 
       var items = stack.Pop(2);
 
       booleanStack.Push(items[0].Equals(items[1]));
+
+      return true;
     }
   }
@@ -20,6 +22,6 @@
   [PushExpression(StackType.Integer, "INTEGER.=")]
   public class IntegerEqualsExpression : EqualsExpression<long> {
-    public override void Eval(IPushInterpreter interpreter) {
-      this.Eval(interpreter.IntegerStack, interpreter.BooleanStack);
+    public override bool Eval(IPushInterpreter interpreter) {
+      return Eval(interpreter.IntegerStack, interpreter.BooleanStack);
     }
   }
@@ -27,6 +29,6 @@
   [PushExpression(StackType.Float, "FLOAT.=")]
   public class FloatEqualsExpression : EqualsExpression<double> {
-    public override void Eval(IPushInterpreter interpreter) {
-      this.Eval(interpreter.FloatStack, interpreter.BooleanStack);
+    public override bool Eval(IPushInterpreter interpreter) {
+      return Eval(interpreter.FloatStack, interpreter.BooleanStack);
     }
   }
@@ -34,6 +36,6 @@
   [PushExpression(StackType.Boolean, "BOOLEAN.=")]
   public class BooleanEqualsExpression : EqualsExpression<bool> {
-    public override void Eval(IPushInterpreter interpreter) {
-      this.Eval(interpreter.BooleanStack, interpreter.BooleanStack);
+    public override bool Eval(IPushInterpreter interpreter) {
+      return Eval(interpreter.BooleanStack, interpreter.BooleanStack);
     }
   }
@@ -41,6 +43,6 @@
   [PushExpression(StackType.Name, "NAME.=")]
   public class NameEqualsExpression : EqualsExpression<string> {
-    public override void Eval(IPushInterpreter interpreter) {
-      this.Eval(interpreter.NameStack, interpreter.BooleanStack);
+    public override bool Eval(IPushInterpreter interpreter) {
+      return Eval(interpreter.NameStack, interpreter.BooleanStack);
     }
   }
@@ -48,6 +50,6 @@
   [PushExpression(StackType.Exec, "EXEC.=")]
   public class ExecEqualsExpression : EqualsExpression<Expression> {
-    public override void Eval(IPushInterpreter interpreter) {
-      this.Eval(interpreter.ExecStack, interpreter.BooleanStack);
+    public override bool Eval(IPushInterpreter interpreter) {
+      return Eval(interpreter.ExecStack, interpreter.BooleanStack);
     }
   }
@@ -55,6 +57,6 @@
   [PushExpression(StackType.Code, "CODE.=")]
   public class CodeEqualsExpression : EqualsExpression<Expression> {
-    public override void Eval(IPushInterpreter interpreter) {
-      this.Eval(interpreter.CodeStack, interpreter.BooleanStack);
+    public override bool Eval(IPushInterpreter interpreter) {
+      return Eval(interpreter.CodeStack, interpreter.BooleanStack);
     }
   }
Index: branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/ExecExpressions.cs
===================================================================
--- branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/ExecExpressions.cs	(revision 14733)
+++ branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/ExecExpressions.cs	(revision 14744)
@@ -10,5 +10,5 @@
 
   public class ExecExpandExpression : StatefulExpression<PushProgram> {
-    public static readonly ExecExpandExpression Empty = new ExecExpandExpression();
+    public static readonly ExecExpandExpression Empty = new ExecExpandExpression(PushProgram.Empty);
 
     public ExecExpandExpression(PushProgram program)
@@ -32,6 +32,7 @@
     }
 
-    public override void Eval(IPushInterpreter interpreter) {
+    public override bool Eval(IPushInterpreter interpreter) {
       interpreter.ExecStack.Push(this.State.Expressions);
+      return true;
     }
 
@@ -81,7 +82,7 @@
   [PushExpression(StackType.Exec, "EXEC.IF")]
   public class ExecIfExpression : StatelessExpression {
-    public override void Eval(IPushInterpreter interpreter) {
+    public override bool Eval(IPushInterpreter interpreter) {
       // not enough arguments on stack
-      if ((interpreter.BooleanStack.Count == 0) || (interpreter.ExecStack.Count < 2)) return;
+      if ((interpreter.BooleanStack.Count == 0) || (interpreter.ExecStack.Count < 2)) return false;
 
       var condition = interpreter.BooleanStack.Pop();
@@ -89,4 +90,6 @@
       if (condition) interpreter.ExecStack.RemoveAt(interpreter.ExecStack.Count - 2);
       else interpreter.ExecStack.RemoveTop();
+
+      return true;
     }
   }
@@ -98,17 +101,19 @@
   [PushExpression(StackType.Exec, "EXEC.Y")]
   public class ExecYExpression : StatelessExpression {
-    public override void Eval(IPushInterpreter interpreter) {
+    public override bool Eval(IPushInterpreter interpreter) {
       // not enough arguments on stack
       if (interpreter.ExecStack.Count == 0 ||
           interpreter.Configuration.MaxPointsInProgram < 2)
-        return;
+        return false;
 
       var top = interpreter.ExecStack.Top;
       var execYExpression = ExpressionTable.GetStatelessExpression<ExecYExpression>();
+
       var result = new ExecExpandExpression(top, execYExpression);
 
-      //interpreter.ExecStack.Insert(interpreter.ExecStack.Count - 1, result);
       interpreter.ExecStack.SetTop(result);
       interpreter.ExecStack.Add(top);
+
+      return true;
     }
   }
@@ -119,9 +124,11 @@
   [PushExpression(StackType.Exec, "EXEC.K")]
   public class ExecKExpression : StatelessExpression {
-    public override void Eval(IPushInterpreter interpreter) {
-      if (interpreter.ExecStack.Count < 2) return;
+    public override bool Eval(IPushInterpreter interpreter) {
+      if (interpreter.ExecStack.Count < 2) return false;
 
       var top = interpreter.ExecStack.Pop();
       interpreter.ExecStack.SetTop(top);
+
+      return true;
     }
   }
@@ -134,6 +141,6 @@
   [PushExpression(StackType.Exec, "EXEC.S")]
   public class ExecSExpression : StatelessExpression {
-    public override void Eval(IPushInterpreter interpreter) {
-      if (interpreter.ExecStack.Count < 3) return;
+    public override bool Eval(IPushInterpreter interpreter) {
+      if (interpreter.ExecStack.Count < 3) return false;
 
       var expression = interpreter.ExecStack.Pop(2);
@@ -146,4 +153,6 @@
       interpreter.ExecStack.SetTop(newTop);
       interpreter.ExecStack.Push(c, a);
+
+      return true;
     }
   }
Index: branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/Expression.cs
===================================================================
--- branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/Expression.cs	(revision 14733)
+++ branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/Expression.cs	(revision 14744)
@@ -24,5 +24,5 @@
     }
 
-    public abstract void Eval(IPushInterpreter interpreter);
+    public abstract bool Eval(IPushInterpreter interpreter);
 
     public override string ToString() {
Index: branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/ExpressionTable.cs
===================================================================
--- branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/ExpressionTable.cs	(revision 14733)
+++ branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/ExpressionTable.cs	(revision 14744)
@@ -124,11 +124,12 @@
 
     public static ExecExpandExpression GetProgram(int[] index) {
-      var expressions = new List<Expression>(index.Length);
+      var expressions = new Expression[index.Length];
 
       for (var i = 0; i < index.Length; i++) {
-        expressions.Add(GetExpression(index[i]));
+        expressions[i] = GetExpression(index[i]);
       }
 
-      return new ExecExpandExpression(expressions);
+      var program = new PushProgram(expressions);
+      return new ExecExpandExpression(program);
     }
 
Index: branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/FloatExpressions.cs
===================================================================
--- branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/FloatExpressions.cs	(revision 14733)
+++ branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/FloatExpressions.cs	(revision 14744)
@@ -11,6 +11,6 @@
   [PushExpression(StackType.Float, "FLOAT.+")]
   public class FloatAddExpression : PushResultExpression<double> {
-    public override void Eval(IPushInterpreter interpreter) {
-      Eval(interpreter.FloatStack, 2, values => values[0] + values[1]);
+    public override bool Eval(IPushInterpreter interpreter) {
+      return Eval(interpreter.FloatStack, 2, values => values[0] + values[1]);
     }
   }
@@ -21,6 +21,6 @@
   [PushExpression(StackType.Float, "FLOAT.-")]
   public class FloatSubtractExpression : PushResultExpression<double> {
-    public override void Eval(IPushInterpreter interpreter) {
-      this.Eval(interpreter.FloatStack, 2, values => values[0] - values[1]);
+    public override bool Eval(IPushInterpreter interpreter) {
+      return Eval(interpreter.FloatStack, 2, values => values[0] - values[1]);
     }
   }
@@ -31,6 +31,6 @@
   [PushExpression(StackType.Float, "FLOAT.*")]
   public class FloatMultiplyExpression : PushResultExpression<double> {
-    public override void Eval(IPushInterpreter interpreter) {
-      this.Eval(interpreter.FloatStack, 2, values => values[0] * values[1]);
+    public override bool Eval(IPushInterpreter interpreter) {
+      return Eval(interpreter.FloatStack, 2, values => values[0] * values[1]);
     }
   }
@@ -42,6 +42,6 @@
   [PushExpression(StackType.Float, "FLOAT./")]
   public class FloatDivideExpression : PushResultExpression<double> {
-    public override void Eval(IPushInterpreter interpreter) {
-      this.Eval(interpreter.FloatStack, 2, values => values[0] / values[1], 0);
+    public override bool Eval(IPushInterpreter interpreter) {
+      return Eval(interpreter.FloatStack, 2, values => values[0] / values[1], 0);
     }
   }
@@ -56,6 +56,6 @@
   [PushExpression(StackType.Float, "FLOAT.%")]
   public class FloatModuloExpression : PushResultExpression<double> {
-    public override void Eval(IPushInterpreter interpreter) {
-      this.Eval(interpreter.FloatStack, 2, values => values[0] % values[1], 0);
+    public override bool Eval(IPushInterpreter interpreter) {
+      return Eval(interpreter.FloatStack, 2, values => values[0] % values[1], 0);
     }
   }
@@ -66,6 +66,6 @@
   [PushExpression(StackType.Float, "FLOAT.MIN")]
   public class FloatMinExpression : PushResultExpression<double> {
-    public override void Eval(IPushInterpreter interpreter) {
-      this.Eval(interpreter.FloatStack, 2, values => Math.Min(values[0], values[1]));
+    public override bool Eval(IPushInterpreter interpreter) {
+      return Eval(interpreter.FloatStack, 2, values => Math.Min(values[0], values[1]));
     }
   }
@@ -76,6 +76,6 @@
   [PushExpression(StackType.Float, "FLOAT.MAX")]
   public class FloatMaxExpression : PushResultExpression<double> {
-    public override void Eval(IPushInterpreter interpreter) {
-      this.Eval(interpreter.FloatStack, 2, values => Math.Max(values[0], values[1]));
+    public override bool Eval(IPushInterpreter interpreter) {
+      return Eval(interpreter.FloatStack, 2, values => Math.Max(values[0], values[1]));
     }
   }
@@ -86,6 +86,6 @@
   [PushExpression(StackType.Float, "FLOAT.<")]
   public class FloatSmallerThanExpression : PushResultExpression<double> {
-    public override void Eval(IPushInterpreter interpreter) {
-      this.Eval(interpreter.FloatStack, interpreter.BooleanStack, 2, values => values[0] < values[1]);
+    public override bool Eval(IPushInterpreter interpreter) {
+      return Eval(interpreter.FloatStack, interpreter.BooleanStack, 2, values => values[0] < values[1]);
     }
   }
@@ -96,6 +96,6 @@
   [PushExpression(StackType.Float, "FLOAT.>")]
   public class FloatGreaterThanExpression : PushResultExpression<double> {
-    public override void Eval(IPushInterpreter interpreter) {
-      this.Eval(interpreter.FloatStack, interpreter.BooleanStack, 2, values => values[0] > values[1]);
+    public override bool Eval(IPushInterpreter interpreter) {
+      return Eval(interpreter.FloatStack, interpreter.BooleanStack, 2, values => values[0] > values[1]);
     }
   }
@@ -106,6 +106,6 @@
   [PushExpression(StackType.Float, "FLOAT.SIN")]
   public class FloatSineExpression : PushResultExpression<double> {
-    public override void Eval(IPushInterpreter interpreter) {
-      this.Eval(interpreter.FloatStack, 1, values => Math.Sin(values[0]));
+    public override bool Eval(IPushInterpreter interpreter) {
+      return Eval(interpreter.FloatStack, 1, values => Math.Sin(values[0]));
     }
   }
@@ -116,6 +116,6 @@
   [PushExpression(StackType.Float, "FLOAT.COS")]
   public class FloatCosineExpression : PushResultExpression<double> {
-    public override void Eval(IPushInterpreter interpreter) {
-      this.Eval(interpreter.FloatStack, 1, values => Math.Cos(values[0]));
+    public override bool Eval(IPushInterpreter interpreter) {
+      return Eval(interpreter.FloatStack, 1, values => Math.Cos(values[0]));
     }
   }
@@ -126,6 +126,6 @@
   [PushExpression(StackType.Float, "FLOAT.FROMBOOLEAN")]
   public class FloatFromBooleanExpression : StatelessExpression {
-    public override void Eval(IPushInterpreter interpreter) {
-      if (interpreter.BooleanStack.Count == 0) return;
+    public override bool Eval(IPushInterpreter interpreter) {
+      if (interpreter.BooleanStack.Count == 0) return false;
 
       var condition = interpreter.BooleanStack.Pop();
@@ -133,4 +133,6 @@
 
       interpreter.FloatStack.Push(value);
+
+      return true;
     }
   }
@@ -141,10 +143,12 @@
   [PushExpression(StackType.Float, "FLOAT.FROMINTEGER")]
   public class FloatFromIntegerExpression : StatelessExpression {
-    public override void Eval(IPushInterpreter interpreter) {
-      if (interpreter.IntegerStack.Count == 0) return;
+    public override bool Eval(IPushInterpreter interpreter) {
+      if (interpreter.IntegerStack.Count == 0) return false;
 
       var value = (double)interpreter.IntegerStack.Pop();
 
       interpreter.FloatStack.Push(value);
+
+      return true;
     }
   }
Index: branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/FlushExpressions.cs
===================================================================
--- branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/FlushExpressions.cs	(revision 14733)
+++ branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/FlushExpressions.cs	(revision 14744)
@@ -10,6 +10,7 @@
   /// <typeparam name="T">Stacktype</typeparam>
   public abstract class FlushExpression<T> : StatelessExpression {
-    public void Eval(IStack<T> stack) {
+    public bool Eval(IStack<T> stack) {
       stack.Clear();
+      return true;
     }
   }
@@ -17,6 +18,6 @@
   [PushExpression(StackType.Integer, "INTEGER.FLUSH")]
   public class IntegerFlushExpression : FlushExpression<long> {
-    public override void Eval(IPushInterpreter interpreter) {
-      Eval(interpreter.IntegerStack);
+    public override bool Eval(IPushInterpreter interpreter) {
+      return Eval(interpreter.IntegerStack);
     }
   }
@@ -24,6 +25,6 @@
   [PushExpression(StackType.Float, "FLOAT.FLUSH")]
   public class FloatFlushExpression : FlushExpression<double> {
-    public override void Eval(IPushInterpreter interpreter) {
-      Eval(interpreter.FloatStack);
+    public override bool Eval(IPushInterpreter interpreter) {
+      return Eval(interpreter.FloatStack);
     }
   }
@@ -31,6 +32,6 @@
   [PushExpression(StackType.Boolean, "BOOLEAN.FLUSH")]
   public class BooleanFlushExpression : FlushExpression<bool> {
-    public override void Eval(IPushInterpreter interpreter) {
-      Eval(interpreter.BooleanStack);
+    public override bool Eval(IPushInterpreter interpreter) {
+      return Eval(interpreter.BooleanStack);
     }
   }
@@ -38,6 +39,6 @@
   [PushExpression(StackType.Name, "NAME.FLUSH")]
   public class NameFlushExpression : FlushExpression<string> {
-    public override void Eval(IPushInterpreter interpreter) {
-      Eval(interpreter.NameStack);
+    public override bool Eval(IPushInterpreter interpreter) {
+      return Eval(interpreter.NameStack);
     }
   }
@@ -45,6 +46,6 @@
   [PushExpression(StackType.Exec, "EXEC.FLUSH")]
   public class ExecFlushExpression : FlushExpression<Expression> {
-    public override void Eval(IPushInterpreter interpreter) {
-      Eval(interpreter.ExecStack);
+    public override bool Eval(IPushInterpreter interpreter) {
+      return Eval(interpreter.ExecStack);
     }
   }
@@ -52,6 +53,6 @@
   [PushExpression(StackType.Code, "CODE.FLUSH")]
   public class CodeFlushExpression : FlushExpression<Expression> {
-    public override void Eval(IPushInterpreter interpreter) {
-      Eval(interpreter.CodeStack);
+    public override bool Eval(IPushInterpreter interpreter) {
+      return Eval(interpreter.CodeStack);
     }
   }
Index: branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/IntegerExpressions.cs
===================================================================
--- branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/IntegerExpressions.cs	(revision 14733)
+++ branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/IntegerExpressions.cs	(revision 14744)
@@ -12,6 +12,6 @@
   [PushExpression(StackType.Integer, "INTEGER.+")]
   public class IntegerAddExpression : PushResultExpression<long> {
-    public override void Eval(IPushInterpreter interpreter) {
-      this.Eval(interpreter.IntegerStack, 2, values => values[0] + values[1]);
+    public override bool Eval(IPushInterpreter interpreter) {
+      return Eval(interpreter.IntegerStack, 2, values => values[0] + values[1]);
     }
   }
@@ -22,6 +22,6 @@
   [PushExpression(StackType.Integer, "INTEGER.-")]
   public class IntegerSubtractExpression : PushResultExpression<long> {
-    public override void Eval(IPushInterpreter interpreter) {
-      this.Eval(interpreter.IntegerStack, 2, values => values[0] - values[1]);
+    public override bool Eval(IPushInterpreter interpreter) {
+      return Eval(interpreter.IntegerStack, 2, values => values[0] - values[1]);
     }
   }
@@ -32,6 +32,6 @@
   [PushExpression(StackType.Integer, "INTEGER.*")]
   public class IntegerMultiplyExpression : PushResultExpression<long> {
-    public override void Eval(IPushInterpreter interpreter) {
-      this.Eval(interpreter.IntegerStack, 2, values => values[0] * values[1]);
+    public override bool Eval(IPushInterpreter interpreter) {
+      return Eval(interpreter.IntegerStack, 2, values => values[0] * values[1]);
     }
   }
@@ -43,6 +43,6 @@
   [PushExpression(StackType.Integer, "INTEGER./")]
   public class IntegerDivideExpression : PushResultExpression<long> {
-    public override void Eval(IPushInterpreter interpreter) {
-      this.Eval(interpreter.IntegerStack, 2, values => values[0] / values[1], 0);
+    public override bool Eval(IPushInterpreter interpreter) {
+      return Eval(interpreter.IntegerStack, 2, values => values[0] / values[1], 0);
     }
   }
@@ -58,6 +58,6 @@
   [PushExpression(StackType.Integer, "INTEGER.%")]
   public class IntegerModuloExpression : PushResultExpression<long> {
-    public override void Eval(IPushInterpreter interpreter) {
-      this.Eval(interpreter.IntegerStack, 2, values => values[0] % values[1], 0);
+    public override bool Eval(IPushInterpreter interpreter) {
+      return Eval(interpreter.IntegerStack, 2, values => values[0] % values[1], 0);
     }
   }
@@ -68,6 +68,6 @@
   [PushExpression(StackType.Integer, "INTEGER.MIN")]
   public class IntegerMinExpression : PushResultExpression<long> {
-    public override void Eval(IPushInterpreter interpreter) {
-      this.Eval(interpreter.IntegerStack, 2, values => Math.Min(values[0], values[1]));
+    public override bool Eval(IPushInterpreter interpreter) {
+      return Eval(interpreter.IntegerStack, 2, values => Math.Min(values[0], values[1]));
     }
   }
@@ -78,6 +78,6 @@
   [PushExpression(StackType.Integer, "INTEGER.MAX")]
   public class IntegerMaxExpression : PushResultExpression<long> {
-    public override void Eval(IPushInterpreter interpreter) {
-      this.Eval(interpreter.IntegerStack, 2, values => Math.Max(values[0], values[1]));
+    public override bool Eval(IPushInterpreter interpreter) {
+      return Eval(interpreter.IntegerStack, 2, values => Math.Max(values[0], values[1]));
     }
   }
@@ -88,6 +88,6 @@
   [PushExpression(StackType.Integer, "INTEGER.<")]
   public class IntegerSmallerThanExpression : PushResultExpression<long> {
-    public override void Eval(IPushInterpreter interpreter) {
-      this.Eval(interpreter.IntegerStack, interpreter.BooleanStack, 2, values => values[0] < values[1]);
+    public override bool Eval(IPushInterpreter interpreter) {
+      return Eval(interpreter.IntegerStack, interpreter.BooleanStack, 2, values => values[0] < values[1]);
     }
   }
@@ -98,6 +98,6 @@
   [PushExpression(StackType.Integer, "INTEGER.>")]
   public class IntegerGreaterThanExpression : PushResultExpression<long> {
-    public override void Eval(IPushInterpreter interpreter) {
-      this.Eval(interpreter.IntegerStack, interpreter.BooleanStack, 2, values => values[0] > values[1]);
+    public override bool Eval(IPushInterpreter interpreter) {
+      return Eval(interpreter.IntegerStack, interpreter.BooleanStack, 2, values => values[0] > values[1]);
     }
   }
@@ -108,6 +108,6 @@
   [PushExpression(StackType.Integer, "INTEGER.FROMBOOLEAN")]
   public class IntegerFromBooleanExpression : StatelessExpression {
-    public override void Eval(IPushInterpreter interpreter) {
-      if (interpreter.BooleanStack.Count == 0) return;
+    public override bool Eval(IPushInterpreter interpreter) {
+      if (interpreter.BooleanStack.Count == 0) return false;
 
       var condition = interpreter.BooleanStack.Pop();
@@ -115,4 +115,6 @@
 
       interpreter.IntegerStack.Push(value);
+
+      return true;
     }
   }
@@ -123,10 +125,12 @@
   [PushExpression(StackType.Integer, "INTEGER.FROMFLOAT")]
   public class IntegerFromFloatExpression : StatelessExpression {
-    public override void Eval(IPushInterpreter interpreter) {
-      if (interpreter.FloatStack.Count == 0) return;
+    public override bool Eval(IPushInterpreter interpreter) {
+      if (interpreter.FloatStack.Count == 0) return false;
 
       var value = (int)interpreter.FloatStack.Pop();
 
       interpreter.IntegerStack.Push(value);
+
+      return true;
     }
   }
Index: branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/LoopExpression.cs
===================================================================
--- branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/LoopExpression.cs	(revision 14733)
+++ branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/LoopExpression.cs	(revision 14744)
@@ -4,6 +4,6 @@
   using HeuristicLab.Problems.ProgramSynthesis.Push.Stack;
 
-  public class LoopState {
-    public LoopState() { }
+  public struct LoopState {
+    //public LoopState() { }
     public LoopState(Expression body, long currentIndex, long destinationIndex, long incrementor) {
       this.Body = body;
@@ -36,8 +36,8 @@
     protected LoopExpression(LoopState state) : base(state) { }
 
-    protected void Eval(IPushInterpreter interpreter, IStack<Expression> sourceStack, bool pushCurrentIndex = false) {
+    protected bool Eval(IPushInterpreter interpreter, IStack<Expression> sourceStack, bool pushCurrentIndex = false) {
       // if not initialized
       if (this.State.Body == null) {
-        if (this.HasInsufficientArguments(interpreter, sourceStack)) return;
+        if (this.HasInsufficientArguments(interpreter, sourceStack)) return false;
 
         var state = this.InitState(interpreter, sourceStack);
@@ -45,5 +45,5 @@
 
         interpreter.ExecStack.Push(initLoopExpression, state.Body);
-        return;
+        return true;
       }
 
@@ -51,11 +51,11 @@
       if (this.State.DestinationIndex == this.State.CurrentIndex) {
         this.PushLastIteration(interpreter);
-        return;
+        return true;
       }
 
       this.PushIteration(interpreter);
+
+      return true;
     }
-
-    protected abstract LoopExpression Clone(LoopState state);
 
     protected virtual void PushIteration(IPushInterpreter interpreter) {
@@ -73,28 +73,6 @@
     }
 
-    //public override bool Equals(object obj) {
-    //  if (this == obj)
-    //    return true;
-
-    //  if (obj == null || obj.GetType() != this.GetType())
-    //    return false;
-
-    //  var other = obj as LoopExpression;
-
-    //  if (this.State.CurrentIndex != other.State.CurrentIndex ||
-    //      this.State.DestinationIndex != other.State.DestinationIndex ||
-    //      this.State.Incrementor != other.State.Incrementor)
-    //    return false;
-
-    //  var isBodyEqual = this.State.Body == other.State.Body ||
-    //                    (this.State.Body != null &&
-    //                    other.State.Body != null &&
-    //                    this.State.Body.Equals(other.State.Body));
-
-    //  return isBodyEqual;
-    //}
-
+    protected abstract LoopExpression Clone(LoopState state);
     protected abstract bool HasInsufficientArguments(IPushInterpreter interpreter, IStack<Expression> sourceStack);
-
     protected abstract LoopState InitState(IPushInterpreter interpreter, IStack<Expression> sourceStack);
   }
Index: branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/NameExpressions.cs
===================================================================
--- branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/NameExpressions.cs	(revision 14733)
+++ branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/NameExpressions.cs	(revision 14744)
@@ -8,5 +8,5 @@
     public NameDefineXExecExpression(string state) : base(state) { }
 
-    public override void Eval(IPushInterpreter interpreter) {
+    public override bool Eval(IPushInterpreter interpreter) {
       Expression expression;
       if (!interpreter.IsNameQuoteFlagSet &&
@@ -17,4 +17,6 @@
         interpreter.IsNameQuoteFlagSet = false;
       }
+
+      return true;
     }
 
@@ -31,6 +33,9 @@
   [PushExpression(StackType.Name, "NAME.QUOTE")]
   public class NameQuoteExpression : StatelessExpression {
-    public override void Eval(IPushInterpreter interpreter) {
+    public override bool Eval(IPushInterpreter interpreter) {
+      if (interpreter.IsNameQuoteFlagSet) return false;
+
       interpreter.IsNameQuoteFlagSet = true;
+      return true;
     }
   }
@@ -41,7 +46,7 @@
   [PushExpression(StackType.Name, "NAME.RANDBOUNDNAME")]
   public class NameRandBoundNameExpression : StatelessExpression {
-    public override void Eval(IPushInterpreter interpreter) {
+    public override bool Eval(IPushInterpreter interpreter) {
       if (interpreter.CustomExpressions.Count == 0)
-        return;
+        return false;
 
       var index = interpreter.CustomExpressions.Keys.Count == 1
@@ -52,4 +57,6 @@
 
       interpreter.NameStack.Push(state);
+
+      return true;
     }
   }
Index: branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/PopExpressions.cs
===================================================================
--- branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/PopExpressions.cs	(revision 14733)
+++ branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/PopExpressions.cs	(revision 14744)
@@ -6,8 +6,9 @@
 
   public abstract class PopExpression<T> : StatelessExpression {
-    public void Eval(IStack<T> stack) {
-      if (stack.Count == 0) return;
+    public bool Eval(IStack<T> stack) {
+      if (stack.Count == 0) return false;
 
       stack.Pop();
+      return true;
     }
   }
@@ -15,6 +16,6 @@
   [PushExpression(StackType.Integer, "INTEGER.POP")]
   public class IntegerPopExpression : PopExpression<long> {
-    public override void Eval(IPushInterpreter interpreter) {
-      this.Eval(interpreter.IntegerStack);
+    public override bool Eval(IPushInterpreter interpreter) {
+      return Eval(interpreter.IntegerStack);
     }
   }
@@ -22,6 +23,6 @@
   [PushExpression(StackType.Float, "FLOAT.POP")]
   public class FloatPopExpression : PopExpression<double> {
-    public override void Eval(IPushInterpreter interpreter) {
-      this.Eval(interpreter.FloatStack);
+    public override bool Eval(IPushInterpreter interpreter) {
+      return Eval(interpreter.FloatStack);
     }
   }
@@ -29,6 +30,6 @@
   [PushExpression(StackType.Boolean, "BOOLEAN.POP")]
   public class BooleanPopExpression : PopExpression<bool> {
-    public override void Eval(IPushInterpreter interpreter) {
-      this.Eval(interpreter.BooleanStack);
+    public override bool Eval(IPushInterpreter interpreter) {
+      return Eval(interpreter.BooleanStack);
     }
   }
@@ -36,6 +37,6 @@
   [PushExpression(StackType.Name, "NAME.POP")]
   public class NamePopExpression : PopExpression<string> {
-    public override void Eval(IPushInterpreter interpreter) {
-      this.Eval(interpreter.NameStack);
+    public override bool Eval(IPushInterpreter interpreter) {
+      return Eval(interpreter.NameStack);
     }
   }
@@ -43,6 +44,6 @@
   [PushExpression(StackType.Exec, "EXEC.POP")]
   public class ExecPopExpression : PopExpression<Expression> {
-    public override void Eval(IPushInterpreter interpreter) {
-      this.Eval(interpreter.ExecStack);
+    public override bool Eval(IPushInterpreter interpreter) {
+      return Eval(interpreter.ExecStack);
     }
   }
@@ -50,6 +51,6 @@
   [PushExpression(StackType.Code, "CODE.POP")]
   public class CodePopExpression : PopExpression<Expression> {
-    public override void Eval(IPushInterpreter interpreter) {
-      this.Eval(interpreter.CodeStack);
+    public override bool Eval(IPushInterpreter interpreter) {
+      return Eval(interpreter.CodeStack);
     }
   }
